freedombone-app-riot 12KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # Riot Web user interface for Matrix
  12. #
  13. # License
  14. # =======
  15. #
  16. # Copyright (C) 2017 Bob Mottram <bob@freedombone.net>
  17. #
  18. # This program is free software: you can redistribute it and/or modify
  19. # it under the terms of the GNU Affero General Public License as published by
  20. # the Free Software Foundation, either version 3 of the License, or
  21. # (at your option) any later version.
  22. #
  23. # This program is distributed in the hope that it will be useful,
  24. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  25. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  26. # GNU Affero General Public License for more details.
  27. #
  28. # You should have received a copy of the GNU Affero General Public License
  29. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  30. VARIANTS='full full-vim chat'
  31. IN_DEFAULT_INSTALL=0
  32. SHOW_ON_ABOUT=1
  33. RIOT_VERSION='0.13.0'
  34. RIOT_FILENAME="riot-v${RIOT_VERSION}"
  35. RIOT_HASH='b65535c4c3bfe6407b491f55df238847884ab83a9d5cbdd1f8b4d6e31cbb5870'
  36. RIOT_DOWNLOAD_URL="https://github.com/vector-im/riot-web/releases/download/v${RIOT_VERSION}"
  37. RIOT_ONION_PORT=8115
  38. RIOT_ONION_HOSTNAME=
  39. RIOT_DOMAIN_NAME=
  40. RIOT_CODE=
  41. riot_variables=(MY_USERNAME
  42. RIOT_DOMAIN_NAME
  43. MATRIX_DOMAIN_NAME
  44. SYSTEM_TYPE
  45. ONION_ONLY
  46. DDNS_PROVIDER)
  47. function logging_on_riot {
  48. echo -n ''
  49. }
  50. function logging_off_riot {
  51. echo -n ''
  52. }
  53. function remove_user_riot {
  54. echo -n ''
  55. }
  56. function add_user_riot {
  57. echo '0'
  58. }
  59. function install_interactive_riot {
  60. if [[ $ONION_ONLY != "no" ]]; then
  61. RIOT_DOMAIN_NAME='riot.local'
  62. else
  63. RIOT_DETAILS_COMPLETE=
  64. while [ ! $RIOT_DETAILS_COMPLETE ]
  65. do
  66. data=$(tempfile 2>/dev/null)
  67. trap "rm -f $data" 0 1 2 5 15
  68. if [[ $DDNS_PROVIDER == "default@freedns.afraid.org" ]]; then
  69. dialog --backtitle $"Freedombone Configuration" \
  70. --title $"Riot Web user interface for Matrix" \
  71. --form $"\nPlease enter your details.\n\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 13 65 3 \
  72. $"Domain:" 1 1 "$(grep 'RIOT_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 15 40 40 \
  73. $"Code:" 2 1 "$(grep 'RIOT_CODE' temp.cfg | awk -F '=' '{print $2}')" 2 15 40 255 \
  74. 2> $data
  75. else
  76. dialog --backtitle $"Freedombone Configuration" \
  77. --title $"Riot Web user interface for Matrix" \
  78. --form $"\nPlease enter your details. The background image URL can be left blank.\n\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 13 65 2 \
  79. $"Domain:" 1 1 "$(grep 'RIOT_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 15 40 40 \
  80. 2> $data
  81. fi
  82. sel=$?
  83. case $sel in
  84. 1) exit 1;;
  85. 255) exit 1;;
  86. esac
  87. RIOT_DOMAIN_NAME=$(cat $data | sed -n 1p)
  88. if [ $RIOT_DOMAIN_NAME ]; then
  89. TEST_DOMAIN_NAME=$RIOT_DOMAIN_NAME
  90. validate_domain_name
  91. if [[ $TEST_DOMAIN_NAME != $RIOT_DOMAIN_NAME ]]; then
  92. RIOT_DOMAIN_NAME=
  93. dialog --title $"Domain name validation" --msgbox "$TEST_DOMAIN_NAME" 15 50
  94. else
  95. if [[ $DDNS_PROVIDER == "default@freedns.afraid.org" ]]; then
  96. RIOT_CODE=$(cat $data | sed -n 2p)
  97. validate_freedns_code "$RIOT_CODE"
  98. if [ ! $VALID_CODE ]; then
  99. RIOT_DOMAIN_NAME=
  100. fi
  101. fi
  102. fi
  103. fi
  104. if [ $RIOT_DOMAIN_NAME ]; then
  105. RIOT_DETAILS_COMPLETE="yes"
  106. fi
  107. done
  108. # save the results in the config file
  109. write_config_param "RIOT_CODE" "$RIOT_CODE"
  110. fi
  111. write_config_param "RIOT_DOMAIN_NAME" "$RIOT_DOMAIN_NAME"
  112. APP_INSTALLED=1
  113. }
  114. function reconfigure_riot {
  115. echo -n ''
  116. }
  117. function riot_download {
  118. # download
  119. if [ ! -f $INSTALL_DIR/${RIOT_FILENAME}.tar.gz ]; then
  120. wget ${RIOT_DOWNLOAD_URL}/${RIOT_FILENAME}.tar.gz -O $INSTALL_DIR/${RIOT_FILENAME}.tar.gz
  121. fi
  122. if [ ! -f $INSTALL_DIR/${RIOT_FILENAME}.tar.gz ]; then
  123. echo $'Unable to download Riot Web from releases'
  124. exit 62836
  125. fi
  126. cd $INSTALL_DIR
  127. # check the hash
  128. curr_hash=$(sha256sum ${RIOT_FILENAME}.tar.gz | awk -F ' ' '{print $1}')
  129. if [[ "$curr_hash" != "$RIOT_HASH" ]]; then
  130. echo $'Riot download hash does not match'
  131. exit 78352
  132. fi
  133. tar -xzvf ${RIOT_FILENAME}.tar.gz
  134. if [ ! -d $INSTALL_DIR/${RIOT_FILENAME} ]; then
  135. echo $'Unable to extract Riot Web tarball'
  136. exit 542826
  137. fi
  138. cp -r $INSTALL_DIR/${RIOT_FILENAME}/* /var/www/$RIOT_DOMAIN_NAME/htdocs
  139. # customize the login image
  140. if [ -f ~/freedombone/img/logo_riot.png ]; then
  141. cp ~/freedombone/img/logo_riot.png /var/www/$RIOT_DOMAIN_NAME/htdocs/img/logo.png
  142. else
  143. if [ -f /home/$MY_USERNAME/freedombone/img/logo_riot.png ]; then
  144. cp /home/$MY_USERNAME/freedombone/img/logo_riot.png /var/www/$RIOT_DOMAIN_NAME/htdocs/img/logo.png
  145. fi
  146. fi
  147. chown -R www-data:www-data /var/www/$RIOT_DOMAIN_NAME/htdocs
  148. }
  149. function upgrade_riot {
  150. if ! grep -q 'riot version:' $COMPLETION_FILE; then
  151. return
  152. fi
  153. CURR_RIOT_VERSION=$(get_completion_param "riot version")
  154. echo "riot current version: ${CURR_RIOT_VERSION}"
  155. echo "riot app version: ${RIOT_VERSION}"
  156. if [[ "${CURR_RIOT_VERSION}" == "${RIOT_VERSION}" ]]; then
  157. return
  158. fi
  159. riot_download
  160. sed -i "s|riot version.*|riot version:$RIOT_VERSION|g" ${COMPLETION_FILE}
  161. systemctl restart nginx
  162. }
  163. function backup_local_riot {
  164. echo -n ''
  165. }
  166. function restore_local_riot {
  167. echo -n ''
  168. }
  169. function backup_remote_riot {
  170. echo -n ''
  171. }
  172. function restore_remote_riot {
  173. echo -n ''
  174. }
  175. function remove_riot {
  176. function_check remove_onion_service
  177. remove_onion_service riot ${RIOT_ONION_PORT}
  178. nginx_dissite $RIOT_DOMAIN_NAME
  179. if [ -f /etc/nginx/sites-available/$RIOT_DOMAIN_NAME ]; then
  180. rm /etc/nginx/sites-available/$RIOT_DOMAIN_NAME
  181. fi
  182. if [ -d /var/www/$RIOT_DOMAIN_NAME ]; then
  183. rm -rf /var/www/$RIOT_DOMAIN_NAME
  184. fi
  185. remove_completion_param install_riot
  186. sed -i '/riot /d' $COMPLETION_FILE
  187. }
  188. function install_riot {
  189. if [[ $ONION_ONLY != 'no' ]]; then
  190. return
  191. fi
  192. # check that matrix has been installed
  193. if [ ! $MATRIX_DOMAIN_NAME ]; then
  194. exit 687292
  195. fi
  196. if [[ "$MATRIX_DOMAIN_NAME" != *'.'* ]]; then
  197. exit 256288
  198. fi
  199. if [ ! -d /var/lib/matrix ]; then
  200. exit 827334
  201. fi
  202. function_check get_completion_param
  203. MATRIX_ONION_DOMAIN_NAME=$(get_completion_param "matrix onion domain")
  204. apt-get -yq install wget
  205. if [ ! -d /var/www/$RIOT_DOMAIN_NAME/htdocs ]; then
  206. mkdir -p /var/www/$RIOT_DOMAIN_NAME/htdocs
  207. fi
  208. if [ ! -d $INSTALL_DIR ]; then
  209. mkdir $INSTALL_DIR
  210. fi
  211. riot_download
  212. cd /var/www/$RIOT_DOMAIN_NAME/htdocs
  213. cp config.sample.json config.json
  214. if [[ $ONION_ONLY == 'no' ]]; then
  215. sed -i "s|\"default_hs_url\":.*|\"default_hs_url\": \"https://${MATRIX_DOMAIN_NAME}\",|g" config.json
  216. sed -i "s|\"default_is_url\":.*|\"default_is_url\": \"https://${MATRIX_DOMAIN_NAME}\",|g" config.json
  217. sed -i "s|\"integrations_ui_url\":.*|\"integrations_ui_url\": \"\",|g" config.json
  218. sed -i "s|\"integrations_rest_url\":.*|\"integrations_rest_url\": \"\",|g" config.json
  219. sed -i "s|\"bug_report_endpoint_url\":.*|\"bug_report_endpoint_url\": \"https://${MATRIX_DOMAIN_NAME}/bugs\",|g" config.json
  220. sed -i "/\"servers\":/a \"${MATRIX_DOMAIN_NAME}\"," config.json
  221. else
  222. sed -i "s|\"default_hs_url\":.*|\"default_hs_url\": \"http://${MATRIX_ONION_DOMAIN_NAME}\",|g" config.json
  223. sed -i "s|\"default_is_url\":.*|\"default_is_url\": \"http://${MATRIX_ONION_DOMAIN_NAME}\",|g" config.json
  224. sed -i "s|\"integrations_ui_url\":.*|\"integrations_ui_url\": \"\",|g" config.json
  225. sed -i "s|\"integrations_rest_url\":.*|\"integrations_rest_url\": \"\",|g" config.json
  226. sed -i "s|\"bug_report_endpoint_url\":.*|\"bug_report_endpoint_url\": \"http://${MATRIX_ONION_DOMAIN_NAME}/bugs\",|g" config.json
  227. sed -i "/\"servers\":/a \"${MATRIX_ONION_DOMAIN_NAME}\"," config.json
  228. fi
  229. RIOT_ONION_HOSTNAME=$(add_onion_service riot 80 ${RIOT_ONION_PORT})
  230. riot_nginx_site=/etc/nginx/sites-available/$RIOT_DOMAIN_NAME
  231. if [[ $ONION_ONLY == "no" ]]; then
  232. function_check nginx_http_redirect
  233. nginx_http_redirect $RIOT_DOMAIN_NAME
  234. echo 'server {' >> $riot_nginx_site
  235. echo ' listen 443 ssl;' >> $riot_nginx_site
  236. echo ' listen [::]:443 ssl;' >> $riot_nginx_site
  237. echo " server_name $RIOT_DOMAIN_NAME;" >> $riot_nginx_site
  238. echo '' >> $riot_nginx_site
  239. echo ' # Security' >> $riot_nginx_site
  240. function_check nginx_ssl
  241. nginx_ssl $RIOT_DOMAIN_NAME
  242. function_check nginx_disable_sniffing
  243. nginx_disable_sniffing $RIOT_DOMAIN_NAME
  244. echo ' add_header Strict-Transport-Security max-age=15768000;' >> $riot_nginx_site
  245. echo '' >> $riot_nginx_site
  246. echo ' # Logs' >> $riot_nginx_site
  247. echo ' access_log /dev/null;' >> $riot_nginx_site
  248. echo ' error_log /dev/null;' >> $riot_nginx_site
  249. echo '' >> $riot_nginx_site
  250. echo ' # Root' >> $riot_nginx_site
  251. echo " root /var/www/$RIOT_DOMAIN_NAME/htdocs;" >> $riot_nginx_site
  252. echo '' >> $riot_nginx_site
  253. echo ' index index.html;' >> $riot_nginx_site
  254. echo '' >> $riot_nginx_site
  255. echo ' location / {' >> $riot_nginx_site
  256. function_check nginx_limits
  257. nginx_limits $RIOT_DOMAIN_NAME '15m'
  258. echo ' }' >> $riot_nginx_site
  259. echo '' >> $riot_nginx_site
  260. nginx_keybase ${RIOT_DOMAIN_NAME}
  261. echo '}' >> $riot_nginx_site
  262. echo '' >> $riot_nginx_site
  263. else
  264. echo -n '' > $riot_nginx_site
  265. fi
  266. echo 'server {' >> $riot_nginx_site
  267. echo " listen 127.0.0.1:$RIOT_ONION_PORT default_server;" >> $riot_nginx_site
  268. echo " server_name $RIOT_ONION_HOSTNAME;" >> $riot_nginx_site
  269. echo '' >> $riot_nginx_site
  270. function_check nginx_disable_sniffing
  271. nginx_disable_sniffing $RIOT_DOMAIN_NAME
  272. echo '' >> $riot_nginx_site
  273. echo ' # Logs' >> $riot_nginx_site
  274. echo ' access_log /dev/null;' >> $riot_nginx_site
  275. echo ' error_log /dev/null;' >> $riot_nginx_site
  276. echo '' >> $riot_nginx_site
  277. echo ' # Root' >> $riot_nginx_site
  278. echo " root /var/www/$RIOT_DOMAIN_NAME/htdocs;" >> $riot_nginx_site
  279. echo '' >> $riot_nginx_site
  280. echo ' index index.html;' >> $riot_nginx_site
  281. echo '' >> $riot_nginx_site
  282. echo ' location / {' >> $riot_nginx_site
  283. function_check nginx_limits
  284. nginx_limits $RIOT_DOMAIN_NAME '15m'
  285. echo ' }' >> $riot_nginx_site
  286. echo '' >> $riot_nginx_site
  287. nginx_keybase ${RIOT_DOMAIN_NAME}
  288. echo '}' >> $riot_nginx_site
  289. sed '/Content-Security-Policy/d' $riot_nginx_site
  290. sed -i 's| DENY;| SAMEORIGIN;|g' $riot_nginx_site
  291. function_check create_site_certificate
  292. if [ ! -f /etc/ssl/certs/${RIOT_DOMAIN_NAME}.pem ]; then
  293. create_site_certificate $RIOT_DOMAIN_NAME 'yes'
  294. fi
  295. function_check nginx_ensite
  296. nginx_ensite $RIOT_DOMAIN_NAME
  297. function_check add_ddns_domain
  298. add_ddns_domain $RIOT_DOMAIN_NAME
  299. chown -R www-data:www-data /var/www/$RIOT_DOMAIN_NAME/htdocs
  300. systemctl restart nginx
  301. set_completion_param "riot domain" "$RIOT_DOMAIN_NAME"
  302. if ! grep -q "riot version:" ${COMPLETION_FILE}; then
  303. echo "riot version:${RIOT_VERSION}" >> ${COMPLETION_FILE}
  304. else
  305. sed -i "s|riot version.*|riot version:${RIOT_VERSION}|g" ${COMPLETION_FILE}
  306. fi
  307. APP_INSTALLED=1
  308. }
  309. # NOTE: deliberately no exit 0